ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.8 by root, Tue Dec 7 19:55:56 2010 UTC vs.
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 37
38# some configuration options for modules 38# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
60if [ "$STATICPERLRC" ]; then
61 . "$STATICPERLRC"
62else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 63 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 64 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 65 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
66fi
60 67
61############################################################################# 68#############################################################################
62# support 69# support
70
71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
72
73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
63 80
64# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
66$VERSION=0.1 83$VERSION="1.21"
67 84
68BZ2=bz2 85BZ2=bz2
69BZIP2=bzip2 86BZIP2=bzip2
70 87
71fatal() { 88fatal() {
104############################################################################# 121#############################################################################
105# clean 122# clean
106 123
107distclean() { 124distclean() {
108 verblock <<EOF 125 verblock <<EOF
109deleting everything installed by this script 126 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 127EOF
111 128
112 rm -rf "$STATICPERL" 129 rm -rf "$STATICPERL"
113} 130}
114 131
115############################################################################# 132#############################################################################
116# download/configure/compile/install perl 133# download/configure/compile/install perl
117 134
118clean() { 135clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
137}
138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 143}
121 144
122fetch() { 145fetch() {
123 rcd "$STATICPERL" 146 rcd "$STATICPERL"
124 147
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
137trying $URL 160trying $URL
138EOF 161EOF
139 162
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
167 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 169 fi
146 170
147 verblock <<EOF 171 verblock <<EOF
148unpacking perl 172unpacking perl
149EOF 173EOF
150 174
151 mkdir -p unpack 175 mkdir -p unpack
176 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 181 rmdir -p unpack
157 fi 182 fi
158} 183}
159 184
160# similar to GNU-sed -i or perl -pi 185# similar to GNU-sed -i or perl -pi
161sedreplace() { 186sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
188 rm -f "$2"
163 mv "$2~" "$2" 189 mv "$2~" "$2"
190}
191
192configure_failure() {
193 cat <<EOF
194
195
196***
197*** Configure failed - see above for the exact error message(s).
198***
199*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
200*** flags are not supported by your compiler. Less often, this is because
201*** PERL_LIBS either contains a library not available on your system (such as
202*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
203***
204*** You can provide your own flags by creating a ~/.staticperlrc file with
205*** variable assignments. For example (these are the actual values used):
206***
207
208PERL_CC="$PERL_CC"
209PERL_CCFLAGS="$PERL_CCFLAGS"
210PERL_OPTIMIZE="$PERL_OPTIMIZE"
211PERL_LDFLAGS="$PERL_LDFLAGS"
212PERL_LIBS="$PERL_LIBS"
213
214EOF
215 exit 1
164} 216}
165 217
166configure() { 218configure() {
167 fetch 219 fetch
168 220
174configuring $STATICPERL/src/perl-$PERL_VERSION 226configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 227EOF
176 228
177 rm -f "$PERL_PREFIX/staticstamp.install" 229 rm -f "$PERL_PREFIX/staticstamp.install"
178 230
179 make distclean >/dev/null 2>&1 231 "$MAKE" distclean >/dev/null 2>&1
180 232
233 sedreplace '/^#define SITELIB/d' config_h.SH
234
181 # I hate them 235 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 238
185 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
186 244
187# trace configure \ 245# trace configure \
188 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
189 -Uuse64bitint \ 247 -Uuse64bitint \
190 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
191 -Uusedl \ 249 -Uusedl \
192 -Uusethreads \ 250 -Uusethreads \
193 -Uuseithreads \ 251 -Uuseithreads \
194 -Uusemultiplicity \ 252 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 253 -Uusesfio \
197 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
198 -Dcppflags="$PERL_CPPFLAGS" \ 256 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 257 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 261 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 262 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 263 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 264 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 265 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 266 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 267 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 268 -Uman1dir \
212 -Uman3dir \ 269 -Uman3dir \
213 -Usiteman1dir \ 270 -Usiteman1dir \
214 -Usiteman3dir \ 271 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 272 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 273 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 274 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 275 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 276 $PERL_CONFIGURE \
277 -Duseperlio \
220 -dE || fatal "Configure failed" 278 -dE || configure_failure
221 279
222 sedreplace ' 280 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
225 ' config.sh 283 ' config.sh
226 284
285 patchconfig || fatal "patchconfig hook failed"
286
227 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
228 288
229 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
230 290
231 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
232} 303}
233 304
234build() { 305build() {
235 configure 306 configure
236 307
240building $STATICPERL/src/perl-$PERL_VERSION 311building $STATICPERL/src/perl-$PERL_VERSION
241EOF 312EOF
242 313
243 rm -f "$PERL_PREFIX/staticstamp.install" 314 rm -f "$PERL_PREFIX/staticstamp.install"
244 315
245 make || fatal "make: error while building perl" 316 "$MAKE" || fatal "make: error while building perl"
246 317
247 postbuild || fatal "postbuild hook failed" 318 postbuild || fatal "postbuild hook failed"
248} 319}
249 320
250install() { 321install() {
251 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 322 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
252
253 build 323 build
254 324
255 verblock <<EOF 325 verblock <<EOF
256installing $STATICPERL/src/perl-$PERL_VERSION 326installing $STATICPERL/src/perl-$PERL_VERSION
257to $PERL_PREFIX 327to $PERL_PREFIX
258EOF 328EOF
259 329
260 rm -rf "$PERL_PREFIX" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
261 331 ln -sf "perl/lib/" "$STATICPERL/lib"
332
333 mkdir "$STATICPERL/patched"
334
335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
336 rm -rf "$PERL_PREFIX" # by this rm -rf
337
262 make install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
263 339
264 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
265 341
266 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
267 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
268make install UNINST=1 344#CAT make-install-make.sh
269if find blib/arch/auto -type f | grep -q -v .exists; then
270 echo Probably an XS module, rebuilding perl
271 make perl
272 rm -f "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl inst_perl
274 make -f Makefile.aperl map_clean
275fi
276EOF 345EOF
277 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
278 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
279 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
280 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
281 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
282 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
283 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
286 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
287 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
288 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
289 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
290 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
291 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
292 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
293 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
294 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
295 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
296 375
376 touch "$PERL_PREFIX/staticstamp.install"
377 fi
378
379 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
297 NOCHECK_INSTALL=+ 380 NOCHECK_INSTALL=+
298 instcpan $STATICPERL_MODULES 381 instcpan $STATICPERL_MODULES
299 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 382 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
300 383
301 postinstall || fatal "postinstall hook failed" 384 postinstall || fatal "postinstall hook failed"
302 385
303 touch "$PERL_PREFIX/staticstamp.install" 386 touch "$PERL_PREFIX/staticstamp.postinstall"
387 fi
304} 388}
305 389
306############################################################################# 390#############################################################################
307# install a module from CPAN 391# install a module from CPAN
308 392
313installing modules from CPAN 397installing modules from CPAN
314$@ 398$@
315EOF 399EOF
316 400
317 for mod in "$@"; do 401 for mod in "$@"; do
318 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
319 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
320 done 404 done
321 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
322} 406}
323 407
335 for mod in "$@"; do 419 for mod in "$@"; do
336 echo 420 echo
337 echo $mod 421 echo $mod
338 ( 422 (
339 rcd $mod 423 rcd $mod
340 make -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
341 make distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
342 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
343 make || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
344 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
345 make distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
346 exit 0 430 exit 0
347 ) || exit $? 431 ) || exit $?
348 done 432 done
349} 433}
350 434
351############################################################################# 435#############################################################################
352# main 436# main
353 437
354podusage() { 438podusage() {
355 echo 439 echo
440
356 if [ -e "$PERL_PREFIX/bin/perl" ]; then 441 if [ -e "$PERL_PREFIX/bin/perl" ]; then
357 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 442 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
358 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 443 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
359 2>/dev/null && exit 444 2>/dev/null && exit
360 fi 445 fi
446
361 # try whatever perl we can find 447 # try whatever perl we can find
362 perl -MPod::Usage -e \ 448 perl -MPod::Usage -e \
363 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 449 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
364 2>/dev/null && exit 450 2>/dev/null && exit
365 451
366 fatal "displaying documentation requires a working perl - try '$0 install' first" 452 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
367} 453}
368 454
369usage() { 455usage() {
370 podusage 0 456 podusage 0
371} 457}
379#CAT mkbundle 465#CAT mkbundle
380MKBUNDLE 466MKBUNDLE
381} 467}
382 468
383bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
384 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
385 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
473 CACHE="$STATICPERL/cache"
474 mkdir -p "$CACHE"
386 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
387} 476}
388 477
389if [ $# -gt 0 ]; then 478if [ $# -gt 0 ]; then
390 while [ $# -gt 0 ]; do 479 while [ $# -gt 0 ]; do
391 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 480 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
392 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 481 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
393 482
394 command="${1#--}"; shift 483 command="${1#--}"; shift
395 case "$command" in 484 case "$command" in
485 version )
486 echo "staticperl version $VERSION"
487 ;;
396 fetch | configure | build | install | clean | distclean) 488 fetch | configure | build | install | clean | realclean | distclean)
397 verblock <<EOF
398$command
399EOF
400 ( "$command" ) 489 ( "$command" ) || exit
401 ;; 490 ;;
402 instsrc ) 491 instsrc )
403 ( instsrc "$@" ) 492 ( instsrc "$@" ) || exit
404 exit 493 exit
405 ;; 494 ;;
406 instcpan ) 495 instcpan )
407 ( instcpan "$@" ) 496 ( instcpan "$@" ) || exit
497 exit
498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
408 exit 502 exit
409 ;; 503 ;;
410 cpan ) 504 cpan )
411 ( install ) 505 ( install ) || exit
412 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
413 exit 507 exit
414 ;; 508 ;;
415 mkbundle ) 509 mkbundle )
416 ( install ) 510 ( install ) || exit
417 bundle "$@" 511 bundle "$@"
418 exit 512 exit
419 ;; 513 ;;
420 mkperl ) 514 mkperl )
421 ( install ) 515 ( install ) || exit
422 bundle --perl "$@" 516 bundle --perl "$@"
517 exit
518 ;;
519 mkapp )
520 ( install ) || exit
521 bundle --app "$@"
423 exit 522 exit
424 ;; 523 ;;
425 help ) 524 help )
426 podusage 2 525 podusage 2
427 ;; 526 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines